local myname="ZifnabsMapper"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={map=Me} else ZifnabsMod.map=Me end
local mod
local L
local C
local db

Me.WorldMapDataProvider = CreateFromMixins(MapCanvasDataProviderMixin)
ZifnabsWorldmapPinMixin = CreateFromMixins(MapCanvasPinMixin)

local worldmapPins={}
local tick={zone=nil}

-- local id=WorldmapFrame:GetMapID()
-- WorldmapFrame:AddDataProvider(Me.WorldMapDataProvider)

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	C=fwinfo.C
	db=fwinfo.db
	mod.core:Register4Event("TICK","map",Me.Tick)
end
function Me:PostInit() 
	Me.WorldMapDataProvider:RefreshAllData() 
end

function Me:Tick(elapsed)
	local x,y,zone,pos,zone_nr=mod.loc:GetLoc()
	if zone and zone~=tick.zone then
		tick.zone=zone
--		for modname,info in pairs(interested.zone) do 
--			interested.zone[modname].list=info.run(does_not_go_to_method,zone,zone_nr) 
--		end
		Me.WorldMapDataProvider:RefreshAllData()
	end
end

-- --------------------------------------------------------------------------------------
-- WORLDMAP DATAPROVIDER : REMOVE ALL DATA
-- --------------------------------------------------------------------------------------
function Me.WorldMapDataProvider:RemoveAllData()
--	self:GetMap():RemoveAllPinsByTemplate("ZifnabsWorldmapPinTemplate")
	wipe(worldmapPins)
end

-- --------------------------------------------------------------------------------------
-- WORLDMAP DATAPROVIDER : REFRESH ALL DATA
-- --------------------------------------------------------------------------------------
function Me.WorldMapDataProvider:RefreshAllData(fromOnShow)
	self:RemoveAllData()
--	local uiMapID = self:GetMap():GetMapID()
	if uiMapID then
		for i,db_type in pairs(GatherMate.db_types) do
local nodesforzone={} --GatherMate:GetNodesForZone(uiMapID, db_type)		
			for coord, nodeID in nodesforzone do
				local pin = self:GetMap():AcquirePin("ZifnabsWorldmapPinTemplate", coord,  nodeID, db_type, uiMapID)
				table.insert(worldmapPins, pin)
			end
		end
	end
end

-- --------------------------------------------------------------------------------------
-- WORLDMAP PIN MIXIN : ON LOAD
-- --------------------------------------------------------------------------------------
function ZifnabsWorldmapPinMixin:OnLoad()
mod.f:Print("wmpm on load")
	self:UseFrameLevelType("PIN_FRAME_LEVEL_AREA_POI")
	self:SetScalingLimits(1, 1.0, 1.2);
end

-- --------------------------------------------------------------------------------------
-- WORLDMAP PIN MIXIN : ON ACQUIRED
-- --------------------------------------------------------------------------------------
function ZifnabsWorldmapPinMixin:OnAcquired(pos,icon) -- mal schauen welche infos hier rein sollen
mod.f:Print("wmpm on acquired")
	local x,y = mod.loc:ParseLoc(pos)
	self:SetPosition(x, y)

	self.pos = pos
	self.tooltipText="wtf"
	self.worldmap = true

	self:SetHeight(12)
	self:SetWidth(12)
	self:SetAlpha(1)
	self.texture:SetTexture("Interface/AddOns/Zifnabs/Icons/Other/Unknown_red.tga")
	self.texture:SetTexCoord(0, 1, 0, 1)
	self.texture:SetVertexColor(1, 1, 1, 1)
	self:EnableMouse(true)
end

-- --------------------------------------------------------------------------------------
-- WORLDMAP PIN MIXIN : ON MOUSE EVENTS
-- --------------------------------------------------------------------------------------
function ZifnabsWorldmapPinMixin:OnMouseEnter() 
mod.f:Print("mouse enter")
end
function ZifnabsWorldmapPinMixin:OnMouseLeave()
mod.f:Print("mouse leave")
end
function ZifnabsWorldmapPinMixin:OnClick(button)
mod.f:Print("mouse click")
end